using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Student
{
	//Klasa EdytujStudent jest interfejsem umoliwiajacym edycj danych
    public class EdytujStudent: System.Web.UI.Page
	{
    

        int NrAlbumu = 0;
		protected System.Web.UI.WebControls.Label nrAlbumuLabel;
		protected System.Web.UI.WebControls.TextBox NazwiskoPole;
		protected System.Web.UI.WebControls.TextBox ImiePole;
		protected System.Web.UI.WebControls.TextBox WydzialPole;
		protected System.Web.UI.WebControls.LinkButton updateButton;
		protected System.Web.UI.WebControls.LinkButton cancelButton;
		protected System.Web.UI.WebControls.TextBox AdresPole;
		protected System.Web.UI.WebControls.LinkButton deleteButton;
      

        private void Page_Load(object sender, System.EventArgs e)
		{
			// Sprawdzenie autoryzacji dania
		if (Request.IsAuthenticated ==false)
		{
			Response.Redirect("~/ochrona/BrakUprawnien.aspx");
			}
			
			//sprawdzenie czy strona jest uruchamiana z parametrem okreslajacym nr Albumu
			// parametr ten stanowi warto komrki w kolumnie nrAlbumu w tabeli Student 
			if (Request.Params["nrAlbumu"] != null) 
			{
				//Przypisanie parametru do zmiennej NrAlbumu
				// zmiana typu zmiennej z integer na string
				NrAlbumu = Int32.Parse(Request.Params["nrAlbumu"]);
			}

			if (Page.IsPostBack == false) 
			{
				//Przypisanie zawartoci kontrolki
				nrAlbumuLabel.Text="brak";
                //Sprawdzenie czy zosta ju przypisany nr albumu
				if (NrAlbumu!= 0)
				{
				
               // ***Pobieranie jednego wiersza z danymi studenta z tabeli Student***
					// Tworzenie egzemplarza klasy StudentCRT     
					Student.StudentCTR dane = new Student.StudentCTR();
                    //Wczytanie danych
					SqlDataReader dr = dane.ZobaczJednegoStudenta(NrAlbumu);
                
                    // czytanie pierwszego wiersza
                    dr.Read();
                    // do kadego pola jest przypisywana warto komrki z tabeli Student
					NazwiskoPole.Text = (String) dr["nazwisko"];
                    ImiePole.Text = (String) dr["imie"];
                    AdresPole.Text = (String) dr["adres"];
                    WydzialPole.Text = (String) dr["wydzial"];
                   
                    // zamknicie odczytu danych
                    dr.Close();
					//Przypisanie kontrolce wartoci zmiennej NrAlbumu
					//jednoczenie nastepuje zapisanie tej zmiennej w postaci string
					nrAlbumuLabel.Text =NrAlbumu.ToString();
                }
			
                
            }
        }

        // Zdarzenie UpdateBtn_Click wywoane przyciskiem "Zatwierd" umoliwa
		// dodanie lub uaktualnienie danych
        private void UpdateBtn_Click(Object sender, EventArgs e) {

            
                // Tworzenie egzemplarza klasy StudentCTR
                Student.StudentCTR dane = new  Student.StudentCTR();

                if (NrAlbumu == 0) {

                    // Dodanie danych do tabeli Student po przez odwoanie si do metody DodajStudenta 
                    dane.DodajStudenta( NrAlbumu,NazwiskoPole.Text, ImiePole.Text, AdresPole.Text,WydzialPole.Text,Context.User.Identity.Name );
                }
                else {

                    // Poprawienie danych w tabeli Student
                    dane.PoprawStudenta( NrAlbumu,NazwiskoPole.Text, ImiePole.Text, AdresPole.Text,WydzialPole.Text,Context.User.Identity.Name );
                }
				// powrt na stron pocztkow
				Response.Redirect("~/DesktopDefault.aspx");
              
        }

        // Zdarzenie DeleteBtn_Click wywoane przyciskiem "Kasuj" umoliwa
		// skasowanie danych
        private void DeleteBtn_Click(Object sender, EventArgs e) 
		{
			//Sprawdzenie czy wiersz zawiera dane 
            if (NrAlbumu != 0) {
				// Tworzenie egzemplarza klasy StudentCTR
                Student.StudentCTR dane = new Student.StudentCTR ();
                //Wywoanie metody
				dane.KasujStudenta(NrAlbumu);
            }
				// powrt na stron pocztkow
			Response.Redirect("~/DesktopDefault.aspx");
         
        }
		
		// Zdarzenie CancelBtn_Click wywoane przyciskiem "Zrezygnuj" umoliwa
		// powrt na stron pocztkow bez zmianw bazie danych
        private void CancelBtn_Click(Object sender, EventArgs e) 
		{
			// powrt na stron pocztkow
			Response.Redirect("~/DesktopDefault.aspx");
        }
        
        public EdytujStudent() 
		{
            Page.Init += new System.EventHandler(Page_Init);
        }

        private void Page_Init(object sender, EventArgs e)
		{
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
        }

		#region Web Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {    
			this.updateButton.Click += new System.EventHandler(this.UpdateBtn_Click);
			this.cancelButton.Click += new System.EventHandler(this.CancelBtn_Click);
			this.deleteButton.Click += new System.EventHandler(this.DeleteBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		
    }
}
