using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Web.SessionState;

namespace Student
{
	//Klasa PoprawOcene jest interfejsem umoliwiajacym poprawianie ocen
    public class PoprawOcene: System.Web.UI.Page
	{
    
        int NrAlbumu = 0;
		int IdOceny=0;
		protected System.Web.UI.WebControls.Label nrAlbumuLabel;
		protected System.Web.UI.WebControls.LinkButton updateButton;
		protected System.Web.UI.WebControls.Label NazwiskoPole;
		protected System.Web.UI.WebControls.Label ImiePole;
		protected System.Web.UI.WebControls.Label WydzialPole;
		protected System.Web.UI.WebControls.Label PrzedmiotPole;
		protected System.Web.UI.WebControls.TextBox OcenaPole;
		protected System.Web.UI.WebControls.Label inform;
		protected System.Web.UI.WebControls.LinkButton cancelButton;
      

        private void Page_Load(object sender, System.EventArgs e)
		{
			// Sprawdzenie czy uytkownik ma autoryzacj
		if (Request.IsAuthenticated ==false)
		{
			Response.Redirect("~/ochrona/BrakUprawnien.aspx");
			}
			
			
				//Przypisanie parametrw do zmiennej NrAlbumu i IdOceny
				// zmiana typu zmiennej z integer na string
				NrAlbumu = Int32.Parse(Request.Params["nrAlbumu"]);
				IdOceny = Int32.Parse(Request.Params["idOceny"]);

			if (Page.IsPostBack == false) 
			{
				//Przypisanie zawartoci kontrolki
				nrAlbumuLabel.Text="brak";
                //Sprawdzenie czy zosta ju przypisany nr albumu i id oceny
				if ((NrAlbumu!= 0)&&(IdOceny!=0))
				{
				
               // ***Pobieranie jednego wiersza z danymi studenta z tabeli Student***
					// Tworzenie egzemplarza klasy StudentCRT     
					Student.StudentCTR dane = new Student.StudentCTR();
                    //Wczytanie danych
					SqlDataReader dr = dane.ZobaczJednegoStudenta(NrAlbumu);
                
                    // czytanie pierwszego wiersza
                    dr.Read();
                    // do kadego pola jest przypisywana warto komrki z tabeli Student
					NazwiskoPole.Text = (String) dr["nazwisko"];
                    ImiePole.Text = (String) dr["imie"];
                    WydzialPole.Text = (String) dr["wydzial"];
                   
                    // zamknicie odczytu danych
                    dr.Close();
					//Przypisanie kontrolce wartoci zmiennej NrAlbumu
					//jednoczenie nastepuje zapisanie tej zmiennej w postaci string
					nrAlbumuLabel.Text =NrAlbumu.ToString();
                }
			
				// Tworzenie egzemplarza klasy OcenaCRT     
				Student.OcenaCTR ocena = new Student.OcenaCTR();
				//Wczytanie danych
				SqlDataReader oc = ocena.ZobaczWybranaOcena(IdOceny);
                
				// czytanie pierwszego wiersza
				oc.Read();
				// do kadego pola jest przypisywana warto odpowiedniej
				PrzedmiotPole.Text = (String) oc["nazwaPrzedmiotu"];
				OcenaPole.Text = ((decimal) oc["ocena"]).ToString();
  
				// zamknicie odczytu danych
				oc.Close();
  

            }
        }

        // Zdarzenie UpdateBtn_Click wywoane przyciskiem "Zatwierd" umoliwa
		// dodanie lub uaktualnienie danych
        private void UpdateBtn_Click(Object sender, EventArgs e) {
			
			// sprawdzenie czy wpisywane dane mieszcz si w prawidowym zakresie
			decimal stopien=Convert.ToDecimal(OcenaPole.Text);
			if((stopien<2) ||(stopien>5))
			{
				inform.Text="BD! Zakres ocen od 2 do 5";
				inform.Visible=true;
			}
			else
			{ 
				// Tworzenie egzemplarza klasy OcenaCTR
				Student.OcenaCTR ocena = new  Student.OcenaCTR();

               
				// Poprawienie danych w tabeli Oceny
				ocena.PoprawOcene(IdOceny,Convert.ToDecimal(OcenaPole.Text),Context.User.Identity.Name );
               
				// powrt na stron pocztkow
				Response.Redirect("~/Wykladowca.aspx");
			}
        }

       
		// Zdarzenie CancelBtn_Click wywoane przyciskiem "Zrezygnuj" umoliwa
		// powrt na stron pocztkow bez zmianw bazie danych
        private void CancelBtn_Click(Object sender, EventArgs e) 
		{
			// powrt na stron pocztkow
			Response.Redirect("~/Wykladowca.aspx");
        }
        
        public PoprawOcene() 
		{
            Page.Init += new System.EventHandler(Page_Init);
        }

        private void Page_Init(object sender, EventArgs e)
		{
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();

			// Sprawdzenie czy uruchamiajacy stron jest wykadowc
			if (StudentOchrona.SprawdzenieFunkcji("Wykladowca") == false)
			{
				Response.Redirect("~/ochrona/BrakUprawnien.aspx");
			}
        }

		#region Web Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {    
			this.updateButton.Click += new System.EventHandler(this.UpdateBtn_Click);
			this.cancelButton.Click += new System.EventHandler(this.CancelBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		
    }
}
