using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Security;
using System.Security.Principal;
using System.Web.Security;
using System.Data.SqlClient;
using System.Threading;
using System.Globalization;

namespace Student
{

	public class Global : System.Web.HttpApplication 
	{
                    
			// Zdarzenie Application_AuthenticateRequest odpowiedzialne jest za autoryzacj aplikacji
		protected void Application_AuthenticateRequest(Object sender, EventArgs e) 
		{
			// Sprawdzenie czy jest autoryzacja 
			if (Request.IsAuthenticated == true) 
			{

				String[] roles;

				// Tworzenie cookies jeli nie jest stworzone jeszcze w tej sesji
				if ((Request.Cookies["studentcookies"] == null) || (Request.Cookies["studentcookies"].Value == "")) 
				{
					// Pobranie rl z tabeli uytkownicy i dodanie do ciasteczka
					UzytkownikCTR user = new UzytkownikCTR();
					roles = user.WezRole(User.Identity.Name);
                
					// stworzenie string, a w celu utwardzenia ciasteczka
					String roleStr = "";
					foreach (String role in roles) 
					{
						roleStr += role;
						roleStr += ";";
					}

					// Tworzenie ciasteczka
					FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
						1,                              // wersja
						Context.User.Identity.Name,     // nazwa uytkownika
						DateTime.Now,                   // czas stworzenia
						DateTime.Now.AddHours(1),       // czas wyganicia
						false,                          // nie utwarzdzenie ciasteczka
						roleStr                         // funkcja(rola) w systemie
						);

					// Zaszyfrowanie ciasteczka
					String cookieStr = FormsAuthentication.Encrypt(ticket);

					// Wysanie ciasteczka do przegldarki klienta
					Response.Cookies["studentcookies"].Value = cookieStr;
					Response.Cookies["studentcookies"].Path = "/";
					Response.Cookies["studentcookies"].Expires = DateTime.Now.AddMinutes(1);
				}
				else 
				{
					// Gdy ciasteczko jest stworzone
					// Pobranie roli z ciasteczka
					FormsAuthenticationTicket ticket = FormsAuthentication.Decrypt(Context.Request.Cookies["studentcookies"].Value);

					//konwersja roli z danych na liste uporzadkowan
					ArrayList userRoles = new ArrayList();

					foreach (String role in ticket.UserData.Split( new char[] {';'} )) 
					{
						userRoles.Add(role);
					}

					roles = (String[]) userRoles.ToArray(typeof(String));
				}

				// dodanie do gwnego zapytania ciasteczka z uwzgldnieniem roli
				Context.User = new GenericPrincipal(Context.User.Identity, roles);
				
			}
		}

		// Metoda GetApplicationPath zwraca prawidow ciek
		public static string GetApplicationPath(HttpRequest request) 
		{
			string path = string.Empty;
			try 
			{
				if(request.ApplicationPath != "/")
					path = request.ApplicationPath;
			}
			catch (Exception e)
			{
				throw e;
			}

			return path;
		}
	}
}


