using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using Student;

namespace Student
{

    // Klasa OcenaCTR poredniczy pomidzy klasami interfejsu uytkownika a baz danych
    public class OcenaCTR 
	{

        // Metoda ZobaczOceny umoliwia wywielenie w postaci tabelarycznej danych o ocenach

        public DataSet ZobaczOceny(int IdPrzedmiotu )
		{

            // tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definiowanie polecenia z baz danych
            SqlDataAdapter comm = new SqlDataAdapter("Zobacz_Oceny", conn);

            // Zdefiniowanie polecenia jako Stored Procedure
            comm.SelectCommand.CommandType = CommandType.StoredProcedure;
			
			// Dodawanie parametru do Stored Procedure
			SqlParameter parameteridPrzedmiotu = new SqlParameter("@idPrzedmiotu", SqlDbType.NVarChar, 20);
			parameteridPrzedmiotu.Value = IdPrzedmiotu;
			comm.SelectCommand.Parameters.Add(parameteridPrzedmiotu);
			
            // Stworzenie i wypenienie DataSet
            DataSet myDataSet = new DataSet();
            comm.Fill(myDataSet);

            // Zwrcenie DataSet
            return myDataSet;
        }

		// Metoda ZobaczWybranaOcena umoliwia uzyskanie tylko danych o jednej ocenie
		// metoda ta jest wykorzystywana przy wczytaniu danych do edycji
        
		public SqlDataReader ZobaczWybranaOcena(int IdOceny)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Zobacz_WybrOcene", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

            // Dodawanie parametrw do Stored Procedure
            SqlParameter parameteridOceny = new SqlParameter("@idOceny", SqlDbType.Int, 4);
            parameteridOceny.Value = IdOceny;
            comm.Parameters.Add(parameteridOceny);

            // Otworzenie poczenia z abaz danych
            conn.Open();
            //Wykonanie polecenia i zamknicie poczenia z baz danych
			SqlDataReader result = comm.ExecuteReader(CommandBehavior.CloseConnection);
            
            // Zwrot wyniku  
            return result;
        }

		
        // Metoda DodajOcene odpowiada za dodanie oceny do bazy danych
        public int DodajOcene(int NrAlbumu,  int IdOceny,int IdPrzedmiotu, decimal Ocena,String Uzytkownik)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Dodaj_Ocene", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
            SqlParameter parameteridOceny = new SqlParameter("@idOceny", SqlDbType.Int, 4);
            parameteridOceny.Direction = ParameterDirection.Output;
            comm.Parameters.Add(parameteridOceny);

            SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int,4);
            parameternrAlbumu.Value = NrAlbumu;
            comm.Parameters.Add(parameternrAlbumu);

            SqlParameter parameteridPrzedmiotu = new SqlParameter("@idPrzedmiotu ", SqlDbType.NVarChar, 20);
            parameteridPrzedmiotu .Value = IdPrzedmiotu ;
            comm.Parameters.Add(parameteridPrzedmiotu );

            SqlParameter parameterocena = new SqlParameter("@ocena", SqlDbType.Decimal, 9);
            parameterocena.Value = Ocena;
			// ustawienie zmiennej na dokadnoc jednego miejsca po przecinku
			parameterocena.Scale=1;
            comm.Parameters.Add(parameterocena);


			SqlParameter parameteruzytkownik= new SqlParameter("@uzytkownik", SqlDbType.NVarChar, 50);
			parameteruzytkownik.Value = Uzytkownik;
			comm.Parameters.Add(parameteruzytkownik);
			
			// Otworzenie poczenia z baz danych
			conn.Open();
			// Wykonanie polecenia Dodaj_Ocene
			comm.ExecuteNonQuery();
			//Zamknicie poczenia z baz danych
			conn.Close();
			// Zwrot wartoci idOceny
            return (int)parameternrAlbumu.Value;
        }

        //Metoda PoprawOcene jest odpowiedzialna za poprawianie oceny
		public void PoprawOcene (int IdOceny,decimal Ocena,String Uzytkownik)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Popraw_Ocene", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
			SqlParameter parameteridOceny = new SqlParameter("@idOceny", SqlDbType.Int, 4);
			parameteridOceny.Value = IdOceny;
			comm.Parameters.Add(parameteridOceny);
			
			SqlParameter parameterocena = new SqlParameter("@ocena", SqlDbType.Decimal, 9);
			parameterocena.Value = Ocena;
			// ustawienie zmiennej na dokadnoc jednego miejsca po przecinku
			parameterocena.Scale=1;
			comm.Parameters.Add(parameterocena);

			SqlParameter parameteruzytkownik= new SqlParameter("@uzytkownik", SqlDbType.NVarChar, 50);
			parameteruzytkownik.Value = Uzytkownik;
			comm.Parameters.Add(parameteruzytkownik);
			
			// Otworzenie poczenia z baz danych
			conn.Open();
			// Wykonanie polecenia "Popraw_Ocene"
			comm.ExecuteNonQuery();
			//Zamknicie poczenia z baz danych
			conn.Close();
			
		}
    // Metoda WezPrzedmiot umoliwia zaadowanie danych do kontrolki wyboru
		public DataSet WezPrzedmiot() 
		{

			// Stworzenie egzemplarza poczenia i obiektu z poleceniem
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlDataAdapter myCommand = new SqlDataAdapter("Wez_Przedmiot", myConnection);

			// Zaznaczenie, e polecenie jest procedur wbudowan
			myCommand.SelectCommand.CommandType = CommandType.StoredProcedure;

			
			// Stworzenie i wypenienie DataSet
			DataSet myDataSet = new DataSet();
			myCommand.Fill(myDataSet);
			

			// Zwrcenie DataSet
			return myDataSet;
		}
		
		// Metoda umoliwia sprawdzenie czy student nie zosta juz oceniony
		public SqlDataReader SprawdzeniePowtorzenia(int IdPrzedmiotu, int NrAlbumu)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Sprawdzenie_Powtorzenia", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
			SqlParameter parameteridPrzedmiotu = new SqlParameter("@idPrzedmiotu", SqlDbType.Int, 4);
			parameteridPrzedmiotu.Value = IdPrzedmiotu;
			comm.Parameters.Add(parameteridPrzedmiotu);

			SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int, 4);
			parameternrAlbumu.Value = NrAlbumu;
			comm.Parameters.Add(parameternrAlbumu);

			// Otworzenie poczenia z abaz danych
			conn.Open();
			//Wykonanie polecenia i zamknicie poczenia z baz danych
			SqlDataReader result = comm.ExecuteReader(CommandBehavior.CloseConnection);
            
			// Zwrot wyniku  
			return result;
		}
	
	}
}

