using System;
using System.Configuration;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Collections;

namespace Student
{
	// Klasa RoleCTR poredniczy pomidzy klasami interfejsu uytkownika a baz danych
	public class RoleCTR
	{
		// Metoda WezRole odpowiada za wywietlenie nazw rl
		public SqlDataReader WezRole() 
		{

			// Tworzenie egzemplarza poczenia i polecenia
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlCommand myCommand = new SqlCommand("Wez_Role", myConnection);

			// Ustawienie polecenia jako procedura wbudowana
			myCommand.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do procedury wbudowanej
		
			// Otworzenie poczenia z baz danych i wykonanie polecenia a nastpnie jej zamknicie
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			// Zwrcenie danych 
			return dr;
		}

		// Metoda DodajRoleUzytkownika dodaje uytkownikowi now rol
		public void DodajRoleUzytkownika(int rolaId, int uzytkownikID) 
		{

			// Tworzenie egzemplarza poczenia i polecenia
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlCommand myCommand = new SqlCommand("Dodaj_RoleUzytkownika", myConnection);

			// Ustawienie polecenia jako procedura wbudowana
			myCommand.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do procedury wbudowanej
			SqlParameter parameterRolaID = new SqlParameter("@RolaID", SqlDbType.Int, 4);
			parameterRolaID.Value = rolaId;
			myCommand.Parameters.Add(parameterRolaID);

			SqlParameter parameteruzytkownikID = new SqlParameter("@uzytkownikID", SqlDbType.Int, 4);
			parameteruzytkownikID.Value = uzytkownikID;
			myCommand.Parameters.Add(parameteruzytkownikID);

			// Otworzenie poczenia z baz danych i wykonanie polecenia a nastpnie jej zamknicie
			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		// Metoda KasujRoleUzytkownika kasuje rol przypisan uytkownikowi
		public void KasujRoleUzytkownika(int rolaId, int uzytkownikID) 
		{

			// Tworzenie egzemplarza poczenia i polecenia
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlCommand myCommand = new SqlCommand("Kasuj_RoleUzytkownika", myConnection);

			// Ustawienie polecenia jako procedura wbudowana
			myCommand.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do procedury wbudowanej
			SqlParameter parameterRolaID = new SqlParameter("@RolaID", SqlDbType.Int, 4);
			parameterRolaID.Value = rolaId;
			myCommand.Parameters.Add(parameterRolaID);

			SqlParameter parameteruzytkownikID = new SqlParameter("@uzytkownikID", SqlDbType.Int, 4);
			parameteruzytkownikID.Value = uzytkownikID;
			myCommand.Parameters.Add(parameteruzytkownikID);

			// Otworzenie poczenia z baz danych i wykonanie polecenia a nastpnie jej zamknicie
			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}
       
		// Metoda WezUzytkownikw zwarca dane o uzytkownikach zdefiniowanych w bazie danych
		public SqlDataReader WezUzytkownikow() 
		{

			// Tworzenie egzemplarza poczenia i polecenia
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlCommand myCommand = new SqlCommand("Wez_Uzytkownikow", myConnection);

			// Ustawienie polecenia jako procedura wbudowana
			myCommand.CommandType = CommandType.StoredProcedure;

			// Otworzenie poczenia z baz danych i wykonanie polecenia a nastpnie jej zamknicie
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			// Zwrcenie danych 
			return dr;
		}
	}
}
