using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using Student;

namespace Student
{

    // Klasa StudentCTR poredniczy pomidzy klasami interfejsu uytkownika a baz danych
    public class StudentCTR 
	{

        // Metoda ZobaczStudentow umoliwia wywielenie w postaci tabelarycznej danych o studentach

        public DataSet ZobaczStudentow()
		{

            // tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definiowanie polecenia z baz danych
            SqlDataAdapter comm = new SqlDataAdapter("Zobacz_Studentow", conn);

            // Zdefiniowanie polecenia jako Stored Procedure
            comm.SelectCommand.CommandType = CommandType.StoredProcedure;

            
            // Stworzenie i wypenienie DataSet
            DataSet myDataSet = new DataSet();
            comm.Fill(myDataSet);

            // Zwrcenie DataSet
            return myDataSet;
        }

		// Metoda ZobaczJednegoStudenta umoliwia uzyskanie tylko danych jednego studenta
		// metoda ta jest wykorzystywana przy wczyatniu danych do edycji
        
		public SqlDataReader ZobaczJednegoStudenta(int NrAlbumu)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Zobacz_JednegoStudenta", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

            // Dodawanie parametrw do Stored Procedure
            SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int, 4);
            parameternrAlbumu.Value = NrAlbumu;
            comm.Parameters.Add(parameternrAlbumu);

            // Otworzenie poczenia z abaz danych
            conn.Open();
            //Wykonanie polecenia i zamknicie poczenia z baz danych
			SqlDataReader result = comm.ExecuteReader(CommandBehavior.CloseConnection);
            
            // Zwrot wyniku  
            return result;
        }

		// Metoda KasujStudenta odpowiedziala jest za umoliwienie skasowania danych studenta z bazy danych
		public void KasujStudenta(int NrAlbumu) 
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Kasuj_Studenta", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
			SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int, 4);
			parameternrAlbumu.Value = NrAlbumu;
			comm.Parameters.Add(parameternrAlbumu);

			// Otworzenie poczenia z baz danych
            conn.Open();
			// Wykonanie polecenia "Kasuj_Studenta"
            comm.ExecuteNonQuery();
            //Zamknicie poczenia z baz danych
			conn.Close();
        }

        // Metoda DodajStudenta odpowiada za dodanie danych o studencie do bazy danych
        public int DodajStudenta(int NrAlbumu,  String Nazwisko, String Imie, String Adres, String Wydzial, String Zmodyfikowal)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Dodaj_Studenta", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
            SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int, 4);
            parameternrAlbumu.Direction = ParameterDirection.Output;
            comm.Parameters.Add(parameternrAlbumu);

            SqlParameter parameternazwisko = new SqlParameter("@nazwisko", SqlDbType.NVarChar,20);
            parameternazwisko.Value = Nazwisko;
            comm.Parameters.Add(parameternazwisko);

            SqlParameter parameterimie = new SqlParameter("@imie", SqlDbType.NVarChar, 20);
            parameterimie.Value = Imie;
            comm.Parameters.Add(parameterimie);

            SqlParameter parameteradres = new SqlParameter("@adres", SqlDbType.NVarChar, 100);
            parameteradres.Value = Adres;
            comm.Parameters.Add(parameteradres);

            SqlParameter parameterwydzial= new SqlParameter("@wydzial", SqlDbType.NVarChar, 50);
            parameterwydzial.Value = Wydzial;
            comm.Parameters.Add(parameterwydzial);

			SqlParameter parameterzmodyfikowal= new SqlParameter("@zmodyfikowal", SqlDbType.NVarChar, 50);
			parameterzmodyfikowal.Value = Zmodyfikowal;
			comm.Parameters.Add(parameterzmodyfikowal);
			
			// Otworzenie poczenia z baz danych
			conn.Open();
			// Wykonanie polecenia Dodaj_Studenta
			comm.ExecuteNonQuery();
			//Zamknicie poczenia z baz danych
			conn.Close();
			// Zwrot wartoci nrAlbumu
            return (int)parameternrAlbumu.Value;
        }

        //Metoda PoprawStudenta jest odpowiedzialna za poprawianie danych studenta
		public void PoprawStudenta (int NrAlbumu,  String Nazwisko, String Imie, String Adres, String Wydzial, String Zmodyfikowal)
		{

			// tworzenie egzeplarza dla poczenia z baz danych
			// parametryPolaczenia sa pobierane z pliku Web.config
			SqlConnection conn= new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			//Definioweanie polecenia z baz danych
			SqlCommand comm = new SqlCommand("Popraw_Studenta", conn);

			// Zdefiniowanie polecenia jako Stored Procedure
			comm.CommandType = CommandType.StoredProcedure;

			// Dodawanie parametrw do Stored Procedure
			SqlParameter parameternrAlbumu = new SqlParameter("@nrAlbumu", SqlDbType.Int, 4);
			parameternrAlbumu.Value = NrAlbumu;
			comm.Parameters.Add(parameternrAlbumu);

			SqlParameter parameternazwisko = new SqlParameter("@nazwisko", SqlDbType.NVarChar,20);
			parameternazwisko.Value = Nazwisko;
			comm.Parameters.Add(parameternazwisko);

			SqlParameter parameterimie = new SqlParameter("@imie", SqlDbType.NVarChar, 20);
			parameterimie.Value = Imie;
			comm.Parameters.Add(parameterimie);

			SqlParameter parameteradres = new SqlParameter("@adres", SqlDbType.NVarChar, 100);
			parameteradres.Value = Adres;
			comm.Parameters.Add(parameteradres);

			SqlParameter parameterwydzial= new SqlParameter("@wydzial", SqlDbType.NVarChar, 50);
			parameterwydzial.Value = Wydzial;
			comm.Parameters.Add(parameterwydzial);
        
			SqlParameter parameterzmodyfikowal= new SqlParameter("@zmodyfikowal", SqlDbType.NVarChar, 50);
			parameterzmodyfikowal.Value = Zmodyfikowal;
			comm.Parameters.Add(parameterzmodyfikowal);

			// Otworzenie poczenia z baz danych
			conn.Open();
			// Wykonanie polecenia "Popraw_Studenta"
			comm.ExecuteNonQuery();
			//Zamknicie poczenia z baz danych
			conn.Close();
			
		}
		public DataSet WezDaneStudent() 
		{

			// Stworzenie egzemplarza poczenia i obiektu z poleceniem
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["parametryPolaczenia"]);
			SqlDataAdapter myCommand = new SqlDataAdapter("Wez_DaneStudent", myConnection);

			// Zaznaczenie, e polecenie jest procedur wbudowan
			myCommand.SelectCommand.CommandType = CommandType.StoredProcedure;

			
			// Stworzenie i wypenienie DataSet
			DataSet myDataSet = new DataSet();
			myCommand.Fill(myDataSet);
			

			// Zwrcenie DataSet
			return myDataSet;
		}
	}
}

