using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Student {

    public class ZarzadzanieUzytkownikami : System.Web.UI.Page 
	{
         protected System.Web.UI.HtmlControls.HtmlGenericControl title;

        int    uzytkownikID   = -1;
        String nazwaUzytkownika= "";
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.CompareValidator CompareValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.TextBox Login;
		protected System.Web.UI.WebControls.TextBox Haslo;
		protected System.Web.UI.WebControls.TextBox SprawdzenieHaslo;
		protected System.Web.UI.WebControls.LinkButton PoprawBtn;
		protected System.Web.UI.WebControls.LinkButton dodaj;
		protected System.Web.UI.WebControls.LinkButton zapamietajBtn;
		protected System.Web.UI.WebControls.DataList funkcjeUzytkownikow;
		protected System.Web.UI.WebControls.DropDownList wszystkieRole;
       
     
        private void Page_Load(object sender, System.EventArgs e) {

            // Sprawdzenie czy obecnie zalogowany uytkownik ma uprawnienia do otworzenia strony
			if (StudentOchrona.SprawdzenieFunkcji("Admins") == false) 
			{
				//Przekierowanie na stron informujac o braku uprawnie
				Response.Redirect("~/ochrona/BrakUprawnien.aspx");
			}

            // Odebranie informacji o uytkowniku
            if (Request.Params["uzytkownikID"] != null) 
			{
                uzytkownikID = Int32.Parse(Request.Params["uzytkownikID"]);
            }
            if (Request.Params["NazwaUzytkownika"] != null) 
			{
                nazwaUzytkownika= (String)Request.Params["NazwaUzytkownika"];
            }
           
			// Przypisanie rl do datalist jeli jest to pierwsza wizyta na stronie
            if (Page.IsPostBack == false) 
			{

                // sprawdzenie czy nowy uytkownik
                if (nazwaUzytkownika== "") {

                    UzytkownikCTR osoby = new UzytkownikCTR ();

                    // tworzenie uniklanego nowego rekordu w bazie danych z danymi uytkownika
                    int uid = -1;
                    int i = 0;

                    while (uid == -1) 
					{

                        String friendlyName = "Dodano" + DateTime.Now.ToString();
                        nazwaUzytkownika= "Nowy uytkownik" + i.ToString();
                        uid = osoby.DodajUzytkownika(friendlyName, nazwaUzytkownika, "");
                        i++;
                    }

                    //Przekierowanie do strony Zarzdzajacej uytkownikiem
					Response.Redirect("~/Admin/ZarzadzanieUzytkownikami.aspx?uzytkownikID=" + uid + "&nazwaUzytkownika=" + nazwaUzytkownika);
               
				}

                BindData();
            }
        }

        	// Zdarzenie zapamietaj_Click zapamituje ustawienia
        private void zapamietaj_Click(Object Sender, EventArgs e)
		{

            // Powrt do strony administratora 
            Response.Redirect("~/Administrator.aspx");
        }

		// Zdarzenie popraw_Click poprawia ustawienia 
        private void popraw_Click(Object sender, EventArgs e)
		{

            // Poprawienie danych w bazie danych
            UzytkownikCTR osoby = new UzytkownikCTR();
            osoby.PoprawUzytkownika(uzytkownikID, Login.Text, StudentOchrona.Szyfr(Haslo.Text));
			// Dodanie roli uzytkownik
			int rwszystkich =2;
			RoleCTR funkcje = new RoleCTR();
			funkcje.DodajRoleUzytkownika(rwszystkich, uzytkownikID);


            // Powrt na stron pocztkow
            Response.Redirect("~/Admin/ZarzadzanieUzytkownikami.aspx?uzytkownikID=" + uzytkownikID + "&nazwaUzytkownika=" + Login.Text);
        }

       //Zdarzenie funkcjeUzytkownikow_ItemCommand kasuje role przypisan uytkownikowi
        private void funkcjeUzytkownikow_ItemCommand(object sender, DataListCommandEventArgs e) 
		{

            RoleCTR funkcje = new RoleCTR();
            int rolaID = (int) funkcjeUzytkownikow.DataKeys[e.Item.ItemIndex];

            // update database
            funkcje.KasujRoleUzytkownika(rolaID, uzytkownikID);

            // Ensure that item is not editable
            funkcjeUzytkownikow.EditItemIndex = -1;

            // Repopulate list
            BindData();
        }

		//Metoda BindData jet pomocnicz metod umoliwiajac wywielenie rl
		//na kontrolkach datalist
        private void BindData()
		{

            // pobranie loginu i hasa
            UzytkownikCTR osoby = new UzytkownikCTR();
            SqlDataReader dr = osoby.WezPojUzytkownika(nazwaUzytkownika);

            // Czytanie pierwszego wiersza z bazy danych
            dr.Read();

            Login.Text = (String) dr["Login"];

            dr.Close();

            // dodanie nazwy uytkownika do tytuu
            if (nazwaUzytkownika!= "") {

                title.InnerText = "Edycja: " + nazwaUzytkownika;
            }

            // wypenienie danymi kontrolki datalist
			funkcjeUzytkownikow.DataSource = osoby.WezRoleUzytkownikow(nazwaUzytkownika);
            funkcjeUzytkownikow.DataBind();

           // popbranie rl z  bazy danych
            RoleCTR funkcje = new RoleCTR();

            // Wypenienie danymi dropdownlist
            wszystkieRole.DataSource = funkcje.WezRole();
            wszystkieRole.DataBind();
        }

        public ZarzadzanieUzytkownikami() {
            Page.Init += new System.EventHandler(Page_Init);
        }

        private void Page_Init(object sender, EventArgs e) {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
        }

        #region Web Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
			this.PoprawBtn.Click += new System.EventHandler(this.popraw_Click);
			this.dodaj.Click += new System.EventHandler(this.dodaj_Click);
			this.funkcjeUzytkownikow.ItemCommand += new System.Web.UI.WebControls.DataListCommandEventHandler(this.funkcjeUzytkownikow_ItemCommand);
			this.zapamietajBtn.Click += new System.EventHandler(this.zapamietaj_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
        #endregion

		private void dodaj_Click(object sender, System.EventArgs e)
		{
			int rolaID;

			//get user id from dropdownlist of existing osoby
			rolaID = Int32.Parse(wszystkieRole.SelectedItem.Value);

			// Add a new userRole to the database
			RoleCTR funkcje = new RoleCTR();
			funkcje.DodajRoleUzytkownika(rolaID, uzytkownikID);

			// Rebind list
			BindData();
		}
    }
}
